/*
Измерение расстояния с помощью УЗ-датчика

После запуска скетча нужно отправить команду p>start; через последовательный порт.
После этого программа продолжит своё выполнение. Каждые 200 мс через последовательный порт
будет отправляться строка вида:
p>Расстояние:133.26;
*/

#include <RPulse.h> // импорт библиотеки RPulse

#define TRIG 7 // пин выходного сигнала
#define ECHO 6 // пин входного сигнала

RPulse pulse; // создание объекта

float dist; // расстояние в сантиметрах

void setup()
{

  // настройка пинов
  pinMode(TRIG, OUTPUT);
  pinMode(ECHO, INPUT);

  // открытие последовательно порта со скоростью 9600 бод
  pulse.init(9600);
  // отслеживаем значение переменной dist
  pulse.watchVar(dist, "Расстояние");

  // приостанавливаем программу до получения команды
  pulse.wait();
}

void loop()
{
  digitalWrite(TRIG, HIGH);
  delayMicroseconds(10);
  digitalWrite(TRIG, LOW);

  // с помощью функции pulseIn измеряем
  // продолжительность сигнала на выходе Echo
  // деление на константу 58.2 переводит расстояние в см
  dist = pulseIn(ECHO, HIGH) / 58.2;
  delay(10); // малая задержка для корректной отправки данных
}
